<!DOCTYPE html>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html xmlns:th="https://www.thymeleaf.org">
    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <!-- Bootstrap CSS -->
        <!--<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">-->
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
        <title>Hello, Codeworld!</title>
        <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14"></script>
        <script src="https://code.jquery.com/jquery-3.6.0.js" integrity="sha256-H+K7U5CnXl1h5ywQfKtSj8PCmoN9aaq30gDh27Xc0jk=" crossorigin="anonymous"></script>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.4/font/bootstrap-icons.css">
    </head>
    <body>
          
            <div class='container' id="app">
                <table class="table">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>Start Time</th>
                            <th>Done</th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="p in processes">
                            <td>{{p.id}}</td>
                            <td>{{p.startTime}}</td>
                            <td>{{p.done}}</td>
                            <td>
                                <button v-on:click="showOutput(p)" class="btn btn-primary">Show Output</button>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <div class="modal modal-lg" tabindex="-1" id="outputModal">
                    <div class="modal-dialog" style="width: 95vw">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title">Process Output</h5>
                                <button type="button" class="btn-close" data-bs-dismiss="modal"
                                        aria-label="Close"></button>
                            </div>
                            <div class="modal-body">
                                <div id="output"></div>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <script th:inline="javascript">
                let packageName=[[${packageName}]];
                let name=[[${name}]];
            </script>
            <script>
                let app=new Vue({
                    el: "#app",
                    data:{
                        processes:[]
                    },
                    methods:{
                        showOutput: function(p){
                            const myModal = new bootstrap.Modal('#outputModal', {

                            });
                            $("#output").text(p.processWrapper.output);
                            myModal.show();
                        }
                    }
                });
                $(document).ready(()=>{
                    $.ajax('/runTaskInfo/packageName/'+packageName+'/name/'+name, {
                        success: function(d){
                            app.processes=d;
                        }
                    });
                    
//                    setInterval(()=>{
//                        let map={};
//                        $.ajax("/runTaskInfo", {
//                            success: function(list){
//                                for(let task of list){
//                                    let app=task.appEntry;
//                                    let key=app.packageName+"."+app.name;
//                                    map[key]=task;
//                                }
//                                console.log(map);
//                                for(let entry of app.appEntries){
//                                    let key=entry.packageName+"."+entry.name;
//                                    if(map[key]){
//                                        console.log("found");
//                                        entry.hasProcess=true;
//                                    }else{
//                                        entry.hasProcess=false;
//                                    }
//                                }
//                            }
//                        });
//                    }, 10000);
                });
            </script>
    </body>
</html>
